#version 450

//uniform
layout (set = 0, binding = 0) uniform sampler u_diffuse_sampler;
layout (set = 1, binding = 0) uniform texture2D u_diffuse_texture[16];

layout (push_constant) uniform PushConstsFs {
    layout(offset = 16) int u_index;
} pushConstsFs;

//varying
layout (location = 1) in vec2 v_texcoord;
layout (location = 2) in vec4 v_diffuse;

//out fragColor
layout (location = 0) out vec4 outFragColor;

void main()
{
    vec4 diffuseColor = texture(sampler2D(u_diffuse_texture[pushConstsFs.u_index], u_diffuse_sampler), v_texcoord);
    outFragColor = diffuseColor * v_diffuse;
}
