#version 450

//attribute
layout (location = 0) in vec3 a_position;
layout (location = 1) in vec2 a_uv;

//varying
layout (location = 7) out vec4 v_diffuse;

//uniform
layout (set = 0, binding = 0) uniform sampler2D u_diffuse_texture;

layout (set = 0, binding = 1) uniform Block
{
    mat4 u_mvp;
    vec4 u_palette_info;// x, y : per pixel uv of an atlas( pallete ) texture
                        //    z : 0 : stroke, 1: line body

    vec4 u_view_info;   // x : distance per unit pixel
                        // y : display scale

    vec4 u_view_level;  // x : view( map ) level ( int part )
                        // y : view level ( flaot part )
} block;



const float int16_scale = 0.00006103515625;

void main()
{
    float offset = ( block.u_view_level.y ) * block.u_palette_info.x;
    vec2 uv = vec2( a_uv.x * int16_scale + offset, a_uv.y * int16_scale );
    v_diffuse = texture( u_diffuse_texture, uv );

    gl_Position = block.u_mvp * vec4( a_position, 1.0 );
}
